﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net;
using System.Net.Sockets;
namespace YSocket.AsyncSocket
{
    public class YunAsyncClientSocket : YunAsyncCommon
    {
        public new Action<string>  ActSendMessage;
        public override void MkNm()
        {
            Nm = "n1";  
        }

        private void SendEventSetup()
        {
            ActSendMessage += SendMessage2;
        }
        public bool Connect()
        {
            if (!CheckSocketStart())
            {
                return false;
            }
            SendEventSetup();
            
            LocalSocket = GetTcpSocket();
            //LocalSocket.Bind(LocalSocketIpEndPoint);
            SocketAsyncEventArgs socketAsync = new SocketAsyncEventArgs();
            socketAsync.Completed += 접속완료;
            socketAsync.RemoteEndPoint = LocalSocketIpEndPoint;
            return  LocalSocket.ConnectAsync(socketAsync);
        }

        private Socket ConnectedSocket { get; set; }
        private void 접속완료(object sender, SocketAsyncEventArgs e)
        {
            ConnectedSocket = e.ConnectSocket;
            ActSysMessage?.Invoke("접속됨");
            e.AcceptSocket = null;
        }
        private void SendMessage( string args)
        {
            lock(_lock)
            {
                if (ConnectedSocket != null)
                {
                    if (ConnectedSocket.Connected)
                    {
                        SocketAsyncEventArgs socketAsync = new SocketAsyncEventArgs();
                        socketAsync.SetBuffer(new byte[1024], 0, 1024);
                        socketAsync.Completed += 전송완료;
                        ConnectedSocket.SendAsync(socketAsync);
                    }
                }
            }
        }

        internal void Close()
        {
            if (ConnectedSocket != null)
            {
                if (ConnectedSocket.Connected)
                {
                    ConnectedSocket.Disconnect(false);
                    ConnectedSocket.Shutdown(SocketShutdown.Both);
                    ConnectedSocket.Close();
                }
                
            }
        }

        private async void SendMessage2( string args)
        {
            if (ConnectedSocket != null)
            {
                if (ConnectedSocket.Connected)
                {
                    await SendData(ConnectedSocket, args);
                }
            }
        }
        private Task<int> SendData(Socket socket ,string args)
        {
            var tcs = new TaskCompletionSource<int>(socket);
            var buffer = Encoding.UTF8.GetBytes(args);
            
            socket.BeginSend(buffer,0,buffer.Length,  SocketFlags.None, ar => {
                try
                {
                    var send = ar.AsyncState as Socket;
                    int sentCnt= send.EndSend(ar);
                    tcs.SetResult(sentCnt);
                }
                catch (Exception er)
                {
                    tcs.SetException(er);
                }
            }, socket);
            return tcs.Task;
        }


        private void 전송완료(object sender, SocketAsyncEventArgs e)
        {
            var n1 = e.BytesTransferred;
            var n2 = e.BufferList;
            var n3 = e.Buffer;
            
            e.DisconnectReuseSocket = true;
            e.Dispose();
        }

    }
}
